package br.usp.nds.agualastro.integracao;

import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.FileReader;
import java.io.InputStreamReader;
import java.nio.ByteBuffer;
import java.util.LinkedList;
import java.util.List;
import java.util.Properties;

import javax.mail.Flags;
import javax.mail.Flags.Flag;
import javax.mail.Folder;
import javax.mail.Message;
import javax.mail.Session;
import javax.mail.Store;
import javax.mail.internet.InternetAddress;
import javax.mail.search.FlagTerm;
import javax.xml.bind.DatatypeConverter;

import org.apache.commons.codec.binary.Base64;

public class Carregador {

	public static void main(String[] args) throws Exception {
		System.out.println(ByteBuffer.wrap(new byte[] {-63, -68, -119, -73}).asFloatBuffer().get(0));
		System.out.println(ByteBuffer.wrap(new byte[] {-62, 58, -15, -70}).asFloatBuffer().get(0));
	}
	
	public List<Mensagem> carregar() throws Exception {
		Properties properties = System.getProperties();
		properties.setProperty("mail.store.protocol", "imaps");
		Session session = Session.getDefaultInstance(properties, null);
		Store store = session.getStore("imaps");
		store.connect("mbox.pullup.com.br", "lastro2=pullup.com.br", "aguadelastro2");
		Folder folder = store.getFolder("INBOX");
		folder.open(Folder.READ_WRITE);
		List<Mensagem> mensagens = new LinkedList<Mensagem>();
		for (Message message : folder.search(new FlagTerm(new Flags(Flag.SEEN), false))) {
			if (message.getFrom() != null && message.getFrom().length > 0 && message.getFrom()[0].toString() != null/* && message.getFrom()[0].toString().endsWith("orbcomm.net")*/) {
				ByteArrayOutputStream baos = new ByteArrayOutputStream();
				message.writeTo(baos);
				BufferedReader reader = new BufferedReader(new InputStreamReader(new ByteArrayInputStream(baos.toByteArray())));
				boolean processar1 = false, processar2 = false;
				String codigo = "";
				for (String line = reader.readLine(); line != null; line = reader.readLine()) {
					if (processar2) {
						codigo += line;
						break;
					}
					if (line.startsWith("Content-Transfer-Encoding: base64")) {
						processar1 = true;
					}
					if (line.isEmpty() && processar1) {
						processar2 = true;
					}
				}
				reader.close();
				byte[] bs = DatatypeConverter.parseBase64Binary(codigo);
				int numSensores = (bs.length - 15) / 2;
				int[] sensores = new int[numSensores];
				for (int j = 0; j < sensores.length; j++) {
					sensores[j] = ByteBuffer.wrap(new byte[] {0, 0, bs[j * 2 + 1], bs[j * 2]}).asIntBuffer().get(0); 
				}
				float latitude = ByteBuffer.wrap(new byte[] {bs[bs.length - 12], bs[bs.length - 13], bs[bs.length - 14], bs[bs.length - 15]}).asFloatBuffer().get(0);
				float longitude = ByteBuffer.wrap(new byte[] {bs[bs.length - 8], bs[bs.length - 9], bs[bs.length - 10], bs[bs.length - 11]}).asFloatBuffer().get(0);
				byte[] instante = {
					(byte)((bs[bs.length - 7] & 0xF) + (((int)bs[bs.length - 7] & 0xF0) >> 4) * 10),
					(byte)((bs[bs.length - 6] & 0xF) + (((int)bs[bs.length - 6] & 0xF0) >> 4) * 10),
					(byte)((bs[bs.length - 5] & 0xF) + (((int)bs[bs.length - 5] & 0xF0) >> 4) * 10),
					(byte)((bs[bs.length - 4] & 0xF) + (((int)bs[bs.length - 4] & 0xF0) >> 4) * 10),
					(byte)((bs[bs.length - 3] & 0xF) + (((int)bs[bs.length - 3] & 0xF0) >> 4) * 10),
					(byte)((bs[bs.length - 2] & 0xF) + (((int)bs[bs.length - 2] & 0xF0) >> 4) * 10)
				};
				Mensagem mensagem = new Mensagem(sensores, latitude, longitude, instante, ((InternetAddress)message.getFrom()[0]).getAddress(), bs[bs.length - 1]); 
				mensagens.add(mensagem);	
			}
			message.setFlag(Flag.SEEN, true);
		}
		return mensagens;
	}
}
