package br.usp.nds.agualastro.modelo;

import java.text.SimpleDateFormat;
import java.util.Date;

import javax.xml.bind.annotation.XmlElement;

import br.usp.nds.agualastro.persistencia.LeituraSensor;

public class Leitura {

	private Date instante;
	private float latitude;
	private float longitude;
	private float valor;
	private int sensor;
	
	public Leitura carregar(LeituraSensor ls) {
		return new Leitura(ls.getAquisicao().getInstante(), ls.getAquisicao().getLatitude(), ls.getAquisicao().getLongitude(), ls.getValor() * ls.getSensor().getCoeficienteAngular() + ls.getSensor().getCoeficienteLinear(), ls.getSensor().getCodigo());
	}

	@XmlElement
	public String getInstanteFormatado2() {
		return new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(instante);
	}
	
	@XmlElement
	public String getInstanteFormatado() {
		return new SimpleDateFormat("yyyyMMddHHmmss").format(instante);
	}
	
	public Leitura(Date instante, float latitude, float longitude, float valor, int sensor) {
		super();
		this.instante = instante;
		this.latitude = latitude;
		this.longitude = longitude;
		this.valor = valor;
		this.sensor = sensor;
	}
	public Leitura() {
		super();
	}
	public int getSensor() {
		return sensor;
	}
	public void setSensor(int sensor) {
		this.sensor = sensor;
	}
	public Date getInstante() {
		return instante;
	}
	public void setInstante(Date instante) {
		this.instante = instante;
	}
	public float getLatitude() {
		return latitude;
	}
	public void setLatitude(float latitude) {
		this.latitude = latitude;
	}
	public float getLongitude() {
		return longitude;
	}
	public void setLongitude(float longitude) {
		this.longitude = longitude;
	}
	public float getValor() {
		return valor;
	}
	public void setValor(float valor) {
		this.valor = valor;
	}
}
