package br.usp.nds.agualastro.persistencia;

import java.io.Serializable;
import java.text.SimpleDateFormat;
import java.util.Date;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Temporal;
import javax.persistence.TemporalType;
import javax.xml.bind.annotation.XmlElement;

@Entity
public class Aquisicao implements Serializable {

	private static final long serialVersionUID = 1L;
	
	@Id
	@Temporal(TemporalType.TIMESTAMP)
	private Date instante;
	private float latitude;
	private float longitude;
	@ManyToOne
	private Navio navio;
	
	public Aquisicao() {
		super();
	}
	public Aquisicao(Date instante, float latitude, float longitude, Navio navio) {
		super();
		this.instante = instante;
		this.latitude = latitude;
		this.longitude = longitude;
		this.navio = navio;
	}
	@XmlElement
	public String getInstanteFormatado() {
		return new SimpleDateFormat("dd/MM/yyyy HH:mm:ss").format(instante);
	}
	@XmlElement
	public String getInstanteInvertido() {
		return new SimpleDateFormat("yyyyMMddHHmmss").format(instante);
	}
	public Date getInstante() {
		return instante;
	}
	public void setInstante(Date instante) {
		this.instante = instante;
	}
	public float getLatitude() {
		return latitude;
	}
	public void setLatitude(float latitude) {
		this.latitude = latitude;
	}
	public float getLongitude() {
		return longitude;
	}
	public void setLongitude(float longitude) {
		this.longitude = longitude;
	}
	public Navio getNavio() {
		return navio;
	}
	public void setNavio(Navio navio) {
		this.navio = navio;
	}
}
