package br.usp.nds.agualastro.persistencia;

import java.io.Serializable;
import java.util.List;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.ManyToOne;

@Entity
public class Navio extends Entidade implements Serializable {

	private static final long serialVersionUID = 1L;
	
	@Id
	private String email;
	private String nome;
	private int codigoSensor1;
	private int codigoSensor2;
	private int codigoSensor3;
	private int codigoSensor4;
	private int codigoSensor5;
	private int codigoSensor6;
	private int codigoSensor7;
	private int codigoSensor8;
	private Integer codigo;
	private String tipo;
	@ManyToOne
	private Cliente cliente;
	
	public List<Navio> listar() {
		if (cliente == null || cliente.getCodigo() == 0) {
			return em.createQuery("SELECT n FROM Navio n ORDER BY n.nome").getResultList();
		}
		return em.createQuery("SELECT n FROM Navio n WHERE n.cliente.codigo = " + cliente.getCodigo() + " ORDER BY n.nome").getResultList();
	}
	
	public void incluir() {
		email = codigo + "";
		em.persist(this);
	}
	
	public void alterar() {
		Navio navio = em.find(Navio.class, codigo + "");
		navio.setCliente(em.find(Cliente.class, cliente.getCodigo()));
		navio.setNome(nome);
		navio.setTipo(tipo);
	}
	
	public void excluir() {
		em.remove(em.find(Navio.class, codigo + ""));
	}
	
	public Integer getCodigo() {
		return codigo;
	}
	public void setCodigo(Integer codigo) {
		this.codigo = codigo;
	}
	public Integer getCodigoSensor1() {
		return codigoSensor1;
	}
	public void setCodigoSensor1(int codigoSensor1) {
		this.codigoSensor1 = codigoSensor1;
	}
	public int getCodigoSensor2() {
		return codigoSensor2;
	}
	public void setCodigoSensor2(int codigoSensor2) {
		this.codigoSensor2 = codigoSensor2;
	}
	public int getCodigoSensor3() {
		return codigoSensor3;
	}
	public void setCodigoSensor3(int codigoSensor3) {
		this.codigoSensor3 = codigoSensor3;
	}
	public int getCodigoSensor4() {
		return codigoSensor4;
	}
	public void setCodigoSensor4(int codigoSensor4) {
		this.codigoSensor4 = codigoSensor4;
	}
	public int getCodigoSensor5() {
		return codigoSensor5;
	}
	public void setCodigoSensor5(int codigoSensor5) {
		this.codigoSensor5 = codigoSensor5;
	}
	public int getCodigoSensor6() {
		return codigoSensor6;
	}
	public void setCodigoSensor6(int codigoSensor6) {
		this.codigoSensor6 = codigoSensor6;
	}
	public int getCodigoSensor7() {
		return codigoSensor7;
	}
	public void setCodigoSensor7(int codigoSensor7) {
		this.codigoSensor7 = codigoSensor7;
	}
	public int getCodigoSensor8() {
		return codigoSensor8;
	}
	public void setCodigoSensor8(int codigoSensor8) {
		this.codigoSensor8 = codigoSensor8;
	}
	public String getEmail() {
		return email;
	}
	public void setEmail(String email) {
		this.email = email;
	}
	public Cliente getCliente() {
		return cliente;
	}
	public void setCliente(Cliente cliente) {
		this.cliente = cliente;
	}
	public String getNome() {
		return nome;
	}
	public void setNome(String nome) {
		this.nome = nome;
	}
	public String getTipo() {
		return tipo;
	}
	public void setTipo(String tipo) {
		this.tipo = tipo;
	}
}
