 package br.usp.nds.agualastro.persistencia;

import java.io.Serializable;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.ManyToOne;
import javax.persistence.Transient;
import javax.xml.bind.annotation.XmlElement;

@Entity
public class Sensor extends Entidade implements Serializable {

	private static final long serialVersionUID = 1L;
	
	@Id
	@GeneratedValue
	private int codigo;
	private String nome;
	private String medida;
	@ManyToOne
	private TipoSensor tipo;
	private float coeficienteAngular;
	private float coeficienteLinear;
	private String modelo;
	private String precisao;
	private String fabricante;
	private String manual;
	@Transient
	private String multiplos;
	@Transient
	private String emailNavio;
	@Transient
	private int posicao;
	
	public Sensor() {
		super();
	}
	public Sensor(int codigo, String nome, String medida,
			float coeficienteAngular, float coeficienteLinear) {
		super();
		this.codigo = codigo;
		this.nome = nome;
		this.medida = medida;
		this.coeficienteAngular = coeficienteAngular;
		this.coeficienteLinear = coeficienteLinear;
	}
	
	public List<Sensor> listar() {
		Navio navio = em.find(Navio.class, emailNavio);
		List<Sensor> sensores = em.createQuery("SELECT s FROM Sensor s WHERE s.codigo IN (" 
				+ navio.getCodigoSensor1() 
				+ ", " + navio.getCodigoSensor2()
				+ ", " + navio.getCodigoSensor3()
				+ ", " + navio.getCodigoSensor4()
				+ ", " + navio.getCodigoSensor5()
				+ ", " + navio.getCodigoSensor6()
				+ ", " + navio.getCodigoSensor7()
				+ ", " + navio.getCodigoSensor8() + ")").getResultList();
		for (Sensor sensor : sensores) {
			if (sensor.getCodigo() == navio.getCodigoSensor1()) {
				sensor.setPosicao(1);
			}
			if (sensor.getCodigo() == navio.getCodigoSensor2()) {
				sensor.setPosicao(2);
			}
			if (sensor.getCodigo() == navio.getCodigoSensor3()) {
				sensor.setPosicao(3);
			}
			if (sensor.getCodigo() == navio.getCodigoSensor4()) {
				sensor.setPosicao(4);
			}
			if (sensor.getCodigo() == navio.getCodigoSensor5()) {
				sensor.setPosicao(5);
			}
			if (sensor.getCodigo() == navio.getCodigoSensor6()) {
				sensor.setPosicao(6);
			}
			if (sensor.getCodigo() == navio.getCodigoSensor7()) {
				sensor.setPosicao(7);
			}
			if (sensor.getCodigo() == navio.getCodigoSensor8()) {
				sensor.setPosicao(8);
			}
		}
		return sensores;
	}
	
	public void incluir() throws Exception {
		Navio navio = em.find(Navio.class, emailNavio);
		if (posicao == 1 && navio.getCodigoSensor1() != 0) {
			throw new Exception("Posio j ocupada!");
		}
		if (posicao == 2 && navio.getCodigoSensor2() != 0) {
			throw new Exception("Posio j ocupada!");
		}
		if (posicao == 3 && navio.getCodigoSensor3() != 0) {
			throw new Exception("Posio j ocupada!");
		}
		if (posicao == 4 && navio.getCodigoSensor4() != 0) {
			throw new Exception("Posio j ocupada!");
		}
		if (posicao == 5 && navio.getCodigoSensor5() != 0) {
			throw new Exception("Posio j ocupada!");
		}
		if (posicao == 6 && navio.getCodigoSensor6() != 0) {
			throw new Exception("Posio j ocupada!");
		}
		if (posicao == 7 && navio.getCodigoSensor7() != 0) {
			throw new Exception("Posio j ocupada!");
		}
		if (posicao == 8 && navio.getCodigoSensor8() != 0) {
			throw new Exception("Posio j ocupada!");
		}
		em.persist(this);
		em.flush();
		em.refresh(this);
		em.createQuery("UPDATE Navio n SET n.codigoSensor" + posicao + " = " + codigo + " WHERE n.email = '" + emailNavio + "'").executeUpdate();
	}
	
	public void alterar() throws Exception {
		Navio navio = em.find(Navio.class, emailNavio);
		int posicaoAnterior = 0;
		if (navio.getCodigoSensor1() == codigo) {
			posicaoAnterior = 1;
		}
		if (navio.getCodigoSensor2() == codigo) {
			posicaoAnterior = 2;
		}
		if (navio.getCodigoSensor3() == codigo) {
			posicaoAnterior = 3;
		}
		if (navio.getCodigoSensor4() == codigo) {
			posicaoAnterior = 4;
		}
		if (navio.getCodigoSensor5() == codigo) {
			posicaoAnterior = 5;
		}
		if (navio.getCodigoSensor6() == codigo) {
			posicaoAnterior = 6;
		}
		if (navio.getCodigoSensor7() == codigo) {
			posicaoAnterior = 7;
		}
		if (navio.getCodigoSensor8() == codigo) {
			posicaoAnterior = 8;
		}
		if (posicao != posicaoAnterior) {
			if (posicao == 1 && navio.getCodigoSensor1() != 0) {
				throw new Exception("Posio j ocupada!");
			}
			if (posicao == 2 && navio.getCodigoSensor2() != 0) {
				throw new Exception("Posio j ocupada!");
			}
			if (posicao == 3 && navio.getCodigoSensor3() != 0) {
				throw new Exception("Posio j ocupada!");
			}
			if (posicao == 4 && navio.getCodigoSensor4() != 0) {
				throw new Exception("Posio j ocupada!");
			}
			if (posicao == 5 && navio.getCodigoSensor5() != 0) {
				throw new Exception("Posio j ocupada!");
			}
			if (posicao == 6 && navio.getCodigoSensor6() != 0) {
				throw new Exception("Posio j ocupada!");
			}
			if (posicao == 7 && navio.getCodigoSensor7() != 0) {
				throw new Exception("Posio j ocupada!");
			}
			if (posicao == 8 && navio.getCodigoSensor8() != 0) {
				throw new Exception("Posio j ocupada!");
			}
			if (posicaoAnterior == 1) navio.setCodigoSensor1(0);
			if (posicaoAnterior == 2) navio.setCodigoSensor2(0);
			if (posicaoAnterior == 3) navio.setCodigoSensor3(0);
			if (posicaoAnterior == 4) navio.setCodigoSensor4(0);
			if (posicaoAnterior == 5) navio.setCodigoSensor5(0);
			if (posicaoAnterior == 6) navio.setCodigoSensor6(0);
			if (posicaoAnterior == 7) navio.setCodigoSensor7(0);
			if (posicaoAnterior == 8) navio.setCodigoSensor8(0);
			em.createQuery("UPDATE Navio n SET n.codigoSensor" + posicao + " = " + codigo + " WHERE n.email = '" + emailNavio + "'").executeUpdate();
		}
		em.merge(this);
	}
	
	public void excluir() {
		em.remove(em.find(Sensor.class, codigo));
		em.createQuery("UPDATE Navio s SET s.codigoSensor1 = 0 WHERE s.codigoSensor1 = " + codigo).executeUpdate();
		em.createQuery("UPDATE Navio s SET s.codigoSensor2 = 0 WHERE s.codigoSensor2 = " + codigo).executeUpdate();
		em.createQuery("UPDATE Navio s SET s.codigoSensor3 = 0 WHERE s.codigoSensor3 = " + codigo).executeUpdate();
		em.createQuery("UPDATE Navio s SET s.codigoSensor4 = 0 WHERE s.codigoSensor4 = " + codigo).executeUpdate();
		em.createQuery("UPDATE Navio s SET s.codigoSensor5 = 0 WHERE s.codigoSensor5 = " + codigo).executeUpdate();
		em.createQuery("UPDATE Navio s SET s.codigoSensor6 = 0 WHERE s.codigoSensor6 = " + codigo).executeUpdate();
		em.createQuery("UPDATE Navio s SET s.codigoSensor7 = 0 WHERE s.codigoSensor7 = " + codigo).executeUpdate();
		em.createQuery("UPDATE Navio s SET s.codigoSensor8 = 0 WHERE s.codigoSensor8 = " + codigo).executeUpdate();
	}
	
	public List listarMultiplos() {
		List result = new LinkedList();
		List<Navio> navios = em.createQuery("SELECT n FROM Navio n WHERE n.email IN (" + multiplos + ") ORDER BY n.nome").getResultList();
		for (Navio navio : navios) {
			Map n = new HashMap();
			n.put("nome", navio.getNome());
			List<Sensor> sensores = em.createQuery("SELECT s FROM Sensor s WHERE "
					+ "s.codigo IN (SELECT n.codigoSensor1 FROM Navio n WHERE n.email IN ('" + navio.getEmail() + "')) OR "
					+ "s.codigo IN (SELECT n.codigoSensor2 FROM Navio n WHERE n.email IN ('" + navio.getEmail() + "')) OR "
					+ "s.codigo IN (SELECT n.codigoSensor3 FROM Navio n WHERE n.email IN ('" + navio.getEmail() + "')) OR "
					+ "s.codigo IN (SELECT n.codigoSensor4 FROM Navio n WHERE n.email IN ('" + navio.getEmail() + "')) OR "
					+ "s.codigo IN (SELECT n.codigoSensor5 FROM Navio n WHERE n.email IN ('" + navio.getEmail() + "')) OR "
					+ "s.codigo IN (SELECT n.codigoSensor6 FROM Navio n WHERE n.email IN ('" + navio.getEmail() + "')) OR "
					+ "s.codigo IN (SELECT n.codigoSensor7 FROM Navio n WHERE n.email IN ('" + navio.getEmail() + "')) OR "
					+ "s.codigo IN (SELECT n.codigoSensor8 FROM Navio n WHERE n.email IN ('" + navio.getEmail() + "')) ORDER BY s.nome"
					).getResultList();
			List ss = new LinkedList();
			for (Sensor sensor : sensores) {
				Map s = new HashMap();
				s.put("codigo", sensor.getCodigo());
				s.put("nome", sensor.getNome());
				ss.add(s);
			}
			n.put("sensores", ss);
			result.add(n);
		}
		return result;
	}
	
	@XmlElement
	public int getPosicao() {
		return posicao;
	}
	public void setPosicao(int posicao) {
		this.posicao = posicao;
	}
	public String getModelo() {
		return modelo;
	}
	public void setModelo(String modelo) {
		this.modelo = modelo;
	}
	public String getPrecisao() {
		return precisao;
	}
	public void setPrecisao(String precisao) {
		this.precisao = precisao;
	}
	public String getFabricante() {
		return fabricante;
	}
	public void setFabricante(String fabricante) {
		this.fabricante = fabricante;
	}
	public String getManual() {
		return manual;
	}
	public void setManual(String manual) {
		this.manual = manual;
	}
	public TipoSensor getTipo() {
		return tipo;
	}
	public void setTipo(TipoSensor tipo) {
		this.tipo = tipo;
	}
	public String getEmailNavio() {
		return emailNavio;
	}
	public void setEmailNavio(String emailNavio) {
		this.emailNavio = emailNavio;
	}
	public int getCodigo() {
		return codigo;
	}
	public void setCodigo(int codigo) {
		this.codigo = codigo;
	}
	public String getMedida() {
		return medida;
	}
	public void setMedida(String medida) {
		this.medida = medida;
	}
	public String getMultiplos() {
		return multiplos;
	}
	public void setMultiplos(String multiplos) {
		this.multiplos = multiplos;
	}
	public float getCoeficienteAngular() {
		return coeficienteAngular;
	}
	public void setCoeficienteAngular(float coeficienteAngular) {
		this.coeficienteAngular = coeficienteAngular;
	}
	public float getCoeficienteLinear() {
		return coeficienteLinear;
	}
	public void setCoeficienteLinear(float coeficienteLinear) {
		this.coeficienteLinear = coeficienteLinear;
	}
	public String getNome() {
		return nome;
	}
	public void setNome(String nome) {
		this.nome = nome;
	}
}
