package br.usp.nds.agualastro.persistencia;

import java.io.Serializable;
import java.util.List;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;

@Entity
public class TipoSensor extends Entidade implements Serializable {

	@Id
	@GeneratedValue
	private int codigo;
	private String nome;
	
	public List<TipoSensor> listar() {
		return em.createQuery("SELECT t FROM TipoSensor t ORDER BY t.nome").getResultList();
	}
	
	public void incluir() {
		em.persist(this);
	}
	
	public void alterar() {
		em.merge(this);
	}
	
	public void excluir() {
		em.remove(em.find(TipoSensor.class, codigo));
	}
	
	public int getCodigo() {
		return codigo;
	}
	public void setCodigo(int codigo) {
		this.codigo = codigo;
	}
	public String getNome() {
		return nome;
	}
	public void setNome(String nome) {
		this.nome = nome;
	}
}
